#!/usr/bin/env python
import pickle
import os
import sys
import __main__

coverageDict={}
coverFile='coverage.dat'

def traceinfo(frame, event, arg, level=0):
    coverageDict[(frame.f_code.co_filename, frame.f_lineno)]=1
    return traceinfo

def printCoverage():
    keys=coverageDict.keys()
    keys.sort()
    for i in keys:
	print 'file: %s,  line %d' % ( i[0], i[1])

def getCoverageData():
    global coverFile
    if not coverFile:
	try:
	    coverFile=os.environ['PYCOVERFILE']
	except:
	    pass

    global coverageDict
    try:
	f=open(coverFile,'r')
	coverageDict=pickle.load(f)
    except:
	pass

def saveCoverageData():
    try:
	f=open(coverFile,'w')
	pickle.dump(coverageDict, f)
    except:
	pass

def myatexit():
    sys.settrace(None)
    saveCoverageData()

def main():
    del sys.argv[0]
    sys.exitfunc=myatexit

    getCoverageData()
    sys.settrace(traceinfo)
    
    execfile(sys.argv[0],__main__.__dict__)

def cover(filename):
    sys.exitfunc=myatexit

    global coverFile
    coverFile=filename

    getCoverageData()
    sys.settrace(traceinfo)
